#!/usr/bin/perl
# 
# test script for Serene Bach libraries
# == written by T.Otani <ootani@segausers.gr.jp> ===
# == Copyright (C) 2004 SimpleBoxes/SerendipityNZ ==

# ======================================
use strict;
use warnings;
use lib qw(./ ../);
use sb::Test;
sb::Test::NetAws->run();

package sb::Test::NetAws;
use vars qw( $VERSION );
$VERSION = '0.02';
# 0.02 [2008/05/27] modified _test to check searching in Japanese
# 0.01 [2007/11/29] fixed a bug in _test
# 0.00 [2007/07/21] created
# --------------------------------------
# // public functions
sub run
{
	my $testcase = sb::Test->new();
	$testcase->add('netaws',\&_test,\&_check);
	$testcase->run();
}
# --------------------------------------
# // private functions
sub _test
{
	eval { require sb::Net::Aws; };
	print $@;
	
	my $aws = sb::Net::Aws->new();
	my $result = $aws->get_data(
		'genre'    => 'Books',
		'keyword'  => 'Serene Bach',# 'カスタマイズ自在のウェブログツール',
		'charcode' => 'utf8',
		# 'asin'     => '4839920486',
	);
	return $result if (!$aws->error);
	print $aws->error;
	return;
}
sub _check
{
	my $result = shift;
	return if (!$result or ref($result) ne 'ARRAY');
	my $check = $result->[0];
	if ($check->{'name'} ne 'Serene Bach オフィシャルガイド~カスタマイズ自在のウェブログツール')
	{
		print $check->{'name'},"\n";
		return;
	}
	if ($check->{'creators'}->[0] ne '大谷 拓也 他')
	{
		print $check->{'creators'}->[0],"\n";
		return;
	}
	if ($check->{'asin'} ne '4839920486')
	{
		print $check->{'asin'},"\n";
		return;
	}
	return 1;
}
